/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialOverlay } from "./FinancialOverlay";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { Type, Number_$type, typeCast, runOn, markType, getEnumerator, Point_$type, fromEnum } from "igniteui-react-core/ES2015/type";
import { CategoryFrame } from "./CategoryFrame";
import { Series } from "./Series";
import { SafeEnumerable } from "./SafeEnumerable";
import { TrendCalculators } from "igniteui-react-core/ES2015/TrendCalculators";
import { AxisRange } from "./AxisRange";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { Polyline } from "igniteui-react-core/ES2015/Polyline";
import { Polygon } from "igniteui-react-core/ES2015/Polygon";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
import { isNaN_ } from "igniteui-react-core/ES2015/number";
import { Flattener } from "igniteui-react-core/ES2015/Flattener";
/**
 * @hidden
 */
export class BollingerBandsOverlay extends FinancialOverlay {
    constructor() {
        super();
        this.pj = 0;
        this.pk = 0;
        this.ph = new List$1(Number_$type, 0);
        this.pi = new List$1(Number_$type, 0);
        this.ab = BollingerBandsOverlay.$;
        this.l4 = new CategoryFrame(4);
        this.l6 = new CategoryFrame(4);
        this.l3 = new CategoryFrame(4);
    }
    is(a, b, c, d) {
        if (this.nk().contains(b)) {
            this.pb = false;
        }
        super.is(a, b, c, d);
        switch (b) {
            case BollingerBandsOverlay.$$p[1]:
                this.pb = false;
                this.i6(false);
                break;
            case BollingerBandsOverlay.$$p[0]:
                this.i6(false);
                break;
        }
    }
    pc() {
        this.ph.clear();
        this.pi.clear();
        let a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.nj), this.pm));
        let b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.nj), this.pm));
        this.pk = 1.7976931348623157E+308;
        this.pj = -1.7976931348623157E+308;
        let c = true;
        let d = true;
        let e = this.pl;
        while (c || d) {
            if (a.moveNext()) {
                this.ph.add(a.current);
            }
            else {
                c = false;
            }
            if (b.moveNext()) {
                this.pi.add(b.current);
            }
            else {
                d = false;
            }
            if (c && d) {
                this.pk = Math.min(this.pk, a.current - b.current * e);
                this.pj = Math.max(this.pj, a.current + b.current * e);
            }
        }
        return true;
    }
    an(a) {
        if (this.ph == null || this.pi == null || a == null || this.bz == null || a != this.mm) {
            return null;
        }
        let b = new AxisRange(this.pk, this.pj);
        return b;
    }
    os(a, b) {
        super.os(a, b);
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.l1;
        let g = this.mm;
        let h = new ScalerParams(0, c, d, f.b8, e);
        let i = new ScalerParams(0, c, d, g.b8, e);
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = typeCast(ISortingAxis_$type, this.l1);
        if (j != null && j.i$b.count != this.bz.count) {
            return;
        }
        let k = 0;
        k = this.ns(c, d, e);
        if (!this.pb) {
            this.pb = this.pc();
            if (this.mm != null) {
                this.mm.cl(true);
            }
        }
        i.b = this.ee();
        let l = this.l1.dw(2, h) - this.l1.dw(1, h);
        for (let m = b.bu.c; m <= b.bu.d; ++m) {
            let n;
            if (j == null) {
                n = b.bu.getBucket(m);
            }
            else {
                let o = j.i$b._inner[m];
                let p = j.i$d(o);
                let q = this.ph._inner[m];
                let r = this.pi._inner[m];
                let s = q;
                let t = r;
                let u = p;
                let v = 1;
                while (m < b.bu.d) {
                    o = j.i$b._inner[m + 1];
                    u = j.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s += this.ph._inner[m];
                    t += this.pi._inner[m];
                    v++;
                }
                s /= v;
                t /= v;
                let w = s - t * this.pl;
                let x = s;
                let y = s + t * this.pl;
                let z = NaN;
                if (!isNaN_(p)) {
                    z = this.l1.dt(p, h);
                }
                n = [z, w, x, y];
            }
            let aa = Math.max(1, l);
            if (!isNaN_(n[0]) && m * aa >= this.pd) {
                if (this.l1 != null && typeCast(ISortingAxis_$type, this.l1) !== null) {
                    n[0] = n[0] + k;
                }
                else {
                    n[0] = f.dt(n[0], h) + k;
                }
                n[1] = g.dt(n[1], i);
                n[2] = g.dt(n[2], i);
                n[3] = g.dt(n[3], i);
                a.f.add(n);
            }
        }
    }
    hp(a, b) {
        super.hp(a, b);
        let c = b;
        if (c != null) {
            c.b1();
        }
    }
    ek(a, b, c) {
        if (this.ph == null) {
            return super.ek(a, b, c);
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.ns(this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.l1.b8, d);
        f.c = this.bs.m3;
        return this.em(this.ph, a, this.l1, f, e, runOn(this, this.nr), b, c);
    }
    fb(a, b) {
        if (this.ph == null) {
            return super.fb(a, b);
        }
        return this.fc(a, b, this.l1, runOn(this, this.nr), this.ph);
    }
    e9(a, b) {
        if (this.ph == null) {
            return super.e9(a, b);
        }
        return this.fa(a, b, this.l1, runOn(this, this.nr), this.ph);
    }
    dv(a, b, c) {
        let d = super.dv(a, b, c);
        if (!this.na(this.nk())) {
            d = false;
        }
        return d;
    }
    ou(a, b) {
        super.ou(a, b);
        let c = typeCast(BollingerBandsOverlayView.$, b);
        let d = this.getEffectiveViewport1(b);
        if (b.bx(a)) {
            c.b1();
            let e = a.f.count;
            let f = (g) => a.f._inner[g][0];
            let g = (h) => a.f._inner[e - 1 - h][0];
            let h = (i) => a.f._inner[i][1];
            let i = (j) => a.f._inner[j][2];
            let j = (k) => a.f._inner[e - 1 - k][3];
            c.b2(e, f, g, h, i, j);
            b.bz(a);
        }
        this.l9.x(this, this.m9(), this.l1, runOn(this, this.lt), this.ny(b), this.n0(b));
        let k = false;
        let l = this.l9.c;
        let m = a.f;
        let n = this.bz.count;
        if (l != null) {
            k = true;
        }
        if (k) {
            let o = new ScalerParams(0, b.bs, b.br, this.l1.b8, d);
            this.or(m, -1, n, this.l1, o, b.n);
        }
        let p = c.b9;
        let q = c.ca;
        let r = c.cb;
        let s = c.b4;
        this.l9.ae(q, true, false, true, true);
        this.l9.ao = null;
        this.l9.an = null;
        this.l9.ae(p, true, false, false, true);
        this.l9.ae(r, true, false, false, true);
        this.l9.ae(s, false, true, false, false);
        s._opacity = this.l9.i * this.d3;
    }
    bf() {
        return new BollingerBandsOverlayView(this);
    }
    im(a) {
        super.im(a);
        this.pg = typeCast(BollingerBandsOverlayView.$, a);
    }
    n1() {
        return 3;
    }
    ee() {
        return Series.ef(this.ph, null);
    }
}
BollingerBandsOverlay.$t = markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
Type.dep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:pl:pp', [1, 2], 'Period:pm:pq', [1, 14]]);
/**
 * @hidden
 */
export class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.a.bw.bz.count - 1);
        if (b <= c) {
            let d = this.f.b0.pl;
            let e = 0;
            let f = 0;
            let g = 0;
            for (let h = b; h <= c; ++h) {
                if (!isNaN_(this.f.b0.ph._inner[h]) && !isNaN_(this.f.b0.pi._inner[h])) {
                    e += this.f.b0.ph._inner[h];
                    f += this.f.b0.pi._inner[h];
                    ++g;
                }
            }
            if (g > 0) {
                e = e / g;
                f = f / g;
                return [0.5 * (b + c), e - f * d, e, e + f * d];
            }
        }
        return [NaN, NaN, NaN, NaN];
    }
}
BollingerBandsBucketCalculator.$t = markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
/**
 * @hidden
 */
export class BollingerBandsOverlayView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.b0 = null;
        this.b5 = new Polygon();
        this.cc = new Polyline();
        this.cd = new Polyline();
        this.ce = new Polyline();
        this.b3 = new Polygon();
        this.b6 = new Polyline();
        this.b7 = new Polyline();
        this.b8 = new Polyline();
        this.b0 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    bv() {
        return new BollingerBandsBucketCalculator(this);
    }
    b2(a, b, c, d, e, f) {
        for (let g of fromEnum(Flattener.d(a, b, d, this.e.er))) {
            this.b5.aj.add({ $type: Point_$type, x: b(g), y: d(g) });
            this.cc.aj.add({ $type: Point_$type, x: b(g), y: d(g) });
        }
        for (let h of fromEnum(Flattener.d(a, b, e, this.e.er))) {
            this.cd.aj.add({ $type: Point_$type, x: b(h), y: e(h) });
        }
        for (let i of fromEnum(Flattener.d(a, c, f, this.e.er))) {
            this.b5.aj.add({ $type: Point_$type, x: c(i), y: f(i) });
            this.ce.aj.add({ $type: Point_$type, x: c(i), y: f(i) });
        }
        this.an();
    }
    b1() {
        this.b5.aj.clear();
        this.cc.aj.clear();
        this.cd.aj.clear();
        this.ce.aj.clear();
        this.an();
    }
    get b4() {
        return this.b5;
    }
    get b9() {
        return this.cc;
    }
    get ca() {
        return this.cd;
    }
    get cb() {
        return this.ce;
    }
    a9() {
        super.a9();
        this.b3.aj = this.b5.aj;
        this.b6.aj = this.cc.aj;
        this.b7.aj = this.cd.aj;
        this.b8.aj = this.ce.aj;
        let a = this.bl();
        this.b3._fill = a;
        this.b3._opacity = 1;
        this.b6._stroke = a;
        this.b6.ac = this.e.ev + 3;
        this.b7._stroke = a;
        this.b7.ac = this.e.ev + 3;
        this.b8._stroke = a;
        this.b8.ac = this.e.ev + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.t(this.b3);
                a.u(this.b6);
                a.u(this.b7);
                a.u(this.b8);
            }
            else {
                a.t(this.b5);
                a.u(this.cc);
                a.u(this.cd);
                a.u(this.ce);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPolygonData(a, this.b5, "FillShape", ["Fill"]);
        this.e.a2.exportPolylineData(a, this.cc, "BottomLine", ["Lower", "Main"]);
        this.e.a2.exportPolylineData(a, this.cd, "CentralLine", ["Central"]);
        this.e.a2.exportPolylineData(a, this.ce, "TopLine", ["Upper"]);
    }
}
BollingerBandsOverlayView.$t = markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);
